using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
	/// 通话记录表
	/// </summary>
	public partial class T_Call_CallRecords
    {
        private readonly DAL.T_Call_CallRecords dal = new DAL.T_Call_CallRecords();
        public T_Call_CallRecords()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return dal.GetMaxId();
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int CallRecordsId)
        {
            return dal.Exists(CallRecordsId);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Call_CallRecords model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Call_CallRecords model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int CallRecordsId)
        {

            return dal.Delete(CallRecordsId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string CallRecordsIdlist)
        {
            return dal.DeleteList(CallRecordsIdlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Call_CallRecords GetModel(int CallRecordsId)
        {

            return dal.GetModel(CallRecordsId);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Call_CallRecords> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Call_CallRecords> DataTableToList(DataTable dt)
        {
            List<Model.T_Call_CallRecords> modelList = new List<Model.T_Call_CallRecords>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                Model.T_Call_CallRecords model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod

        #region 更新来电振铃电话记录信息

        /// <summary>
        /// 更新来电振铃电话记录信息
        /// </summary>
        public bool UpdateCallInRingTelRecord(Model.T_Call_CallRecords model)
        {
            return dal.UpdateCallInRingTelRecord(model);
        }

        #endregion

        #region 更新来电摘机电话记录信息

        /// <summary>
        /// 更新来电摘机电话记录信息
        /// </summary>
        public bool UpdateCallInAnswerTelRecord(Model.T_Call_CallRecords model)
        {
            return dal.UpdateCallInAnswerTelRecord(model);
        }

        #endregion

        #region 更新来电挂断电话记录信息

        /// <summary>
        /// 更新来电挂断电话记录信息
        /// </summary>
        public bool UpdateCallInHookTelRecord(string callId)
        {
            return dal.UpdateCallInHookTelRecord(callId);
        }

        #endregion

        #region 更新来电录音记录信息

        /// <summary>
        /// 更新来电录音记录信息
        /// </summary>
        public bool UpdateCallInPathTelRecord(Model.T_Call_CallRecords model)
        {
            return dal.UpdateCallInPathTelRecord(model);
        }

        #endregion

        #region 根据来电号码获取电话记录
        /// <summary>
        /// 根据来电号码获取电话记录
        /// </summary>
        public Model.T_Call_CallRecords GetModelByTelphone(string CallNumber)
        {

            return dal.GetModelByTelphone(CallNumber);
        }
        #endregion

        #region 根据CallId获取电话记录
        /// <summary>
        /// 根据CallId获取电话记录
        /// </summary>
        public Model.T_Call_CallRecords GetModelByCallId(string CallId)
        {

            return dal.GetModelByCallId(CallId);
        }
        /// <summary>
        /// 根据CallId获取电话记录
        /// </summary>
        public Model.T_Call_CallRecords GetModelByRecordId(string CallId)
        {

            return dal.GetModelByRecordId(CallId);
        }
        #endregion

        #region 更新来电处理状态信息

        /// <summary>
        /// 更新来电处理状态信息
        /// </summary>
        public bool UpdateCallInRecordDealType(string callid, int type)
        {
            return dal.UpdateCallInRecordDealType(callid, type);
        }

        #endregion

        #region 导出通话记录
        /// <summary>
        /// 导出通话记录
        /// </summary>
        /// <param name="strWhere"></param>
        /// <returns></returns>
        public DataSet GetListExpt(string strWhere)
        {
            return dal.GetListExpt(strWhere);
        }
        #endregion
    }
}
